<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="$t('最高分值')" prop="scoreMax">
        <el-input v-model="queryParams.scoreMax" :placeholder="$t('请输入最高分值')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item :label="$t('最低分值')" prop="scoreMin">
        <el-input v-model="queryParams.scoreMin" :placeholder="$t('请输入最低分值')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">{{$t('搜索')}}</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">{{$t('重置')}}</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['customer:credit:create']">{{$t('新增')}}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['customer:credit:export']">{{$t('导出')}}</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column :label="$t('主键')" align="center" prop="id" />
      <el-table-column :label="$t('中文名称')" align="center" prop="nameZh" />
      <el-table-column :label="$t('英文名称')" align="center" prop="nameEn" />
      <el-table-column :label="$t('最低分值')" align="center" prop="scoreMin" />
      <el-table-column :label="$t('最高分值')" align="center" prop="scoreMax" />
      <el-table-column :label="$t('备注')" align="center" prop="remark" />
      <el-table-column :label="$t('创建时间')" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column :label="$t('操作')" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['customer:credit:update']">{{$t('修改')}}</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['customer:credit:delete']">{{$t('删除')}}</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item :label="$t('中文名称')" prop="nameZh">
          <el-input v-model="form.nameZh" :placeholder="$t('请输入中文名称')" />
        </el-form-item>
        <el-form-item :label="$t('英文名称')" prop="nameEn">
          <el-input v-model="form.nameEn" :placeholder="$t('请输入英文名称')" />
        </el-form-item>
        <el-form-item :label="$t('最高分值')" prop="scoreMax">
          <el-input v-model="form.scoreMax" :placeholder="$t('请输入最高分值')" />
        </el-form-item>
        <el-form-item :label="$t('最低分值')" prop="scoreMin">
          <el-input v-model="form.scoreMin" :placeholder="$t('请输入最低分值')" />
        </el-form-item>
        <el-form-item :label="$t('备注')" prop="remark">
          <el-input v-model="form.remark" :placeholder="$t('请输入备注')" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">{{$t('确 定')}}</el-button>
        <el-button @click="cancel">{{$t('取 消')}}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { createCredit, updateCredit, deleteCredit, getCredit, getCreditPage, exportCreditExcel } from "@/api/customer/credit";

export default {
  name: "Credit",
  components: {
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 信用等级列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        scoreMax: null,
        scoreMin: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        nameZh: [{ required: true, message: this.$t('中文名称不能为空'), trigger: "blur" }],
        nameEn: [{ required: true, message: this.$t('英文名称不能为空'), trigger: "blur" }],
        scoreMax: [{ required: true, message: this.$t('最大分值不能为空'), trigger: "blur" }],
        scoreMin: [{ required: true, message: this.$t('最小分值不能为空'), trigger: "blur" }],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 处理查询参数
      let params = {...this.queryParams};
      // 执行查询
      getCreditPage(params).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        nameZh: undefined,
        nameEn: undefined,
        scoreMax: undefined,
        scoreMin: undefined,
        remark: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = this.$t('添加信用等级');
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      getCredit(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = this.$t('修改信用等级');
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updateCredit(this.form).then(response => {
            this.$modal.msgSuccess(this.$t('修改成功'));
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createCredit(this.form).then(response => {
          this.$modal.msgSuccess(this.$t('新增成功'));
          this.open = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm(this.$t('是否确认删除信用等级编号为"') + id + this.$t('"的数据项?')).then(function() {
          return deleteCredit(id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess(this.$t('删除成功'));
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      // 执行导出
      this.$modal.confirm(this.$t('是否确认导出所有信用等级数据项?')).then(() => {
          this.exportLoading = true;
          return exportCreditExcel(params);
        }).then(response => {
          this.$download.excel(response, '${table.classComment}.xls');
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
